package battle;

import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JPanel;

public class MainPanel extends JPanel implements Runnable {

	private static final long serialVersionUID = 716492171902237652L;
	
	public MainPanel() {
		Thread t = new Thread(this);
		t.start();
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		int shiftX = 50;
		int shiftY = 20;
		Matrix m = Matrix.getInstance();
		for(int i = 0; i < m.field.length; i++) {
			for(int j = 0; j < m.field[i].length; j++) {
				switch(m.field[i][j]) {
				case Matrix.NEUTRAL:
					g.setColor(Color.WHITE);
					g.fillRect(shiftX+i*10, shiftY+j*10, 10, 10);
					break;
				case Matrix.BLUE_TEAM:
					g.setColor(Color.BLUE);
					g.fillRect(shiftX+i*10, shiftY+j*10, 10, 10);
					break;
				case Matrix.RED_TEAM:
					g.setColor(Color.RED);
					g.fillRect(shiftX+i*10, shiftY+j*10, 10, 10);
					break;
				}
			}
		}
		g.setColor(Color.BLACK);
		g.drawString("Team BLUE: " + m.getCounter(Matrix.BLUE_TEAM), shiftX, m.size() * 10 + shiftY * 2);
		g.drawString("Team RED : " + m.getCounter(Matrix.RED_TEAM), shiftX, m.size() * 10 + shiftY * 3);
	}

	@Override
	public void run() {
		Matrix m = Matrix.getInstance();
		while(!m.end()) {
			repaint();
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				return;
			}
		}
		repaint();
	}
}
