package battle;

public class Matrix {

	public static final int NEUTRAL = 0;
	public static final int BLUE_TEAM = 1;
	public static final int RED_TEAM= 2;
	
	int[][] field;
	private final int dim = 50;
	private int counterBlue;
	private int counterRed;
	private static Matrix instance;
	
	private Matrix() {
		counterBlue = 0;
		counterRed = 0;
		field = new int[dim][dim];
		for(int i = 0; i < field.length; i++)
			for(int j = 0; j < field[i].length; j++)
				field[i][j] = NEUTRAL;			
	}
	
	public static Matrix getInstance() {
		if(instance == null)
			instance = new Matrix();
		return instance;
	}
	
	public int size() {
		return dim;
	}
	
	public boolean end() {
		return counterBlue+counterRed >= dim*dim;
	}
	
	public synchronized void set(int i, int j, int team) {
		try {
			if(field[i][j] != NEUTRAL) return;
			int value = 1;
			if(counterBlue+counterRed==dim*dim-1)
				value = 500;
			if(team == RED_TEAM) {
				counterRed+= value;
			}
			else if(team == BLUE_TEAM) {
				counterBlue+=value;
			}
			else {
				return;
			}
			field[i][j] = team;
		} catch (Exception e) {
			return;
		}
	}
	
	public int getCounter(int team) {
		if(team == RED_TEAM)
			return counterRed;
		if(team == BLUE_TEAM)
			return counterBlue;
		return 0;
	}
}
